// Generated by purs version 0.11.6
"use strict";
var $foreign = require("./foreign");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Array = require("../Data.Array");
var Data_Char = require("../Data.Char");
var Data_Char_Unicode = require("../Data.Char.Unicode");
var Data_Either = require("../Data.Either");
var Data_Eq = require("../Data.Eq");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_Int = require("../Data.Int");
var Data_Maybe = require("../Data.Maybe");
var Data_Ord = require("../Data.Ord");
var Data_Ring = require("../Data.Ring");
var Data_Semigroup = require("../Data.Semigroup");
var Data_String = require("../Data.String");
var Data_String_Regex = require("../Data.String.Regex");
var Data_String_Regex_Flags = require("../Data.String.Regex.Flags");
var Partial_Unsafe = require("../Partial.Unsafe");
var Prelude = require("../Prelude");
var wordSeparatorRegex = Data_Either.fromRight()(Data_String_Regex.regex("[-_. ]")(Data_String_Regex_Flags.noFlags));
var times = function (s) {
    return function (v) {
        if (v < 1) {
            return "";
        };
        if (v === 1) {
            return s;
        };
        return s + times(s)(v - 1 | 0);
    };
};
var singular = $foreign._singular;
var plural = $foreign._plural;
var modifyFirstChar = function (v) {
    return function (v1) {
        if (v1 === "") {
            return "";
        };
        var v2 = Data_String.uncons(v1);
        if (v2 instanceof Data_Maybe.Just) {
            return v(Data_String.singleton(v2.value0.head)) + v2.value0.tail;
        };
        return v1;
    };
};
var legalizeCharacters = function (isLegal) {
    var mapper = function (c) {
        var $14 = isLegal(c);
        if ($14) {
            return Data_String.fromCharArray([ c ]);
        };
        return "_";
    };
    return $foreign.stringConcatMap(mapper);
};
var isLetterOrUnderscore = function (c) {
    return Data_Char_Unicode.isLetter(c) || c === "_";
};
var isLetterOrUnderscoreOrDigit = function (c) {
    return isLetterOrUnderscore(c) || Data_Char_Unicode.isDigit(c);
};
var isLetterOrLetterNumber = function (c) {
    return Data_Char_Unicode.isLetter(c) || Data_Eq.eq(Data_Maybe.eqMaybe(Data_Char_Unicode.eqGeneralCategory))(Data_Char_Unicode.generalCategory(c))(new Data_Maybe.Just(Data_Char_Unicode.LetterNumber.value));
};
var intToHex = function (width) {
    return function (number) {
        var arr = Data_String.toCharArray(Data_Int.toStringAs(Data_Int.hexadecimal)(number));
        var len = Data_Array.length(arr);
        var $15 = len < width;
        if ($15) {
            return Data_Semigroup.append(Data_Semigroup.semigroupArray)(Data_Array.replicate(width - len | 0)("0"))(arr);
        };
        return arr;
    };
};
var standardUnicodeHexEscape = function (i) {
    var $16 = i <= 65535;
    if ($16) {
        return "\\u" + Data_String.fromCharArray(intToHex(4)(i));
    };
    return "\\U" + Data_String.fromCharArray(intToHex(8)(i));
};
var genericStringEscape = function (escaper) {
    var mapper = function (c) {
        if (c === "\\") {
            return "\\\\";
        };
        if (c === "\"") {
            return "\\\"";
        };
        if (c === "\x0a") {
            return "\\n";
        };
        if (c === "\x09") {
            return "\\t";
        };
        var $18 = Data_Char_Unicode.isPrint(c);
        if ($18) {
            return Data_String.fromCharArray([ c ]);
        };
        return escaper(Data_Char.toCharCode(c));
    };
    return $foreign.stringConcatMap(mapper);
};
var stringEscape = genericStringEscape(standardUnicodeHexEscape);
var decapitalize = modifyFirstChar(Data_String.toLower);
var capitalize = modifyFirstChar(Data_String.toUpper);
var startWithLetter = function (isLetter) {
    return function (upper) {
        return function (str) {
            var modify = (function () {
                if (upper) {
                    return capitalize;
                };
                return decapitalize;
            })();
            var v = Data_String.charAt(0)(str);
            if (v instanceof Data_Maybe.Nothing) {
                return modify("empty");
            };
            if (v instanceof Data_Maybe.Just) {
                var $21 = isLetter(v.value0);
                if ($21) {
                    return modify(str);
                };
                return modify("the" + str);
            };
            throw new Error("Failed pattern match at Data.String.Util line 129, column 8 - line 135, column 31: " + [ v.constructor.name ]);
        };
    };
};
var camelCase = function ($23) {
    return Data_String.joinWith("")(Data_Functor.map(Data_Functor.functorArray)(capitalize)(Data_String_Regex.split(wordSeparatorRegex)($23)));
};
module.exports = {
    camelCase: camelCase, 
    capitalize: capitalize, 
    decapitalize: decapitalize, 
    genericStringEscape: genericStringEscape, 
    intToHex: intToHex, 
    isLetterOrLetterNumber: isLetterOrLetterNumber, 
    isLetterOrUnderscore: isLetterOrUnderscore, 
    isLetterOrUnderscoreOrDigit: isLetterOrUnderscoreOrDigit, 
    legalizeCharacters: legalizeCharacters, 
    plural: plural, 
    singular: singular, 
    standardUnicodeHexEscape: standardUnicodeHexEscape, 
    startWithLetter: startWithLetter, 
    stringEscape: stringEscape, 
    times: times, 
    isInt: $foreign.isInt
};
//# sourceMappingURL=index.js.map
