// Generated by purs version 0.11.6
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Array = require("../Data.Array");
var Data_Eq = require("../Data.Eq");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_List = require("../Data.List");
var Data_List_Types = require("../Data.List.Types");
var Data_Map = require("../Data.Map");
var Data_Maybe = require("../Data.Maybe");
var Data_Monoid = require("../Data.Monoid");
var Data_Ord = require("../Data.Ord");
var Data_Ring = require("../Data.Ring");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Data_String_Util = require("../Data.String.Util");
var Data_Traversable = require("../Data.Traversable");
var Data_Tuple = require("../Data.Tuple");
var Data_Unit = require("../Data.Unit");
var Doc = require("../Doc");
var IRGraph = require("../IRGraph");
var Prelude = require("../Prelude");
var Utils = require("../Utils");
var renderComment = function (v) {
    if (v instanceof Data_Maybe.Just) {
        return " /* " + (v.value0 + " */");
    };
    if (v instanceof Data_Maybe.Nothing) {
        return "";
    };
    throw new Error("Failed pattern match at Language.Golang line 97, column 1 - line 97, column 40: " + [ v.constructor.name ]);
};
var pad = function (n) {
    return function (s) {
        return s + Data_String.fromCharArray(Data_Array.replicate(n - Data_String.length(s) | 0)(" "));
    };
};
var noComment = function (rendered) {
    return Control_Applicative.pure(Doc.applicativeDoc)({
        rendered: rendered, 
        comment: Data_Maybe.Nothing.value
    });
};
var legalize = Data_String_Util.legalizeCharacters(Data_String_Util.isLetterOrUnderscoreOrDigit);
var isValueType = function (v) {
    if (v instanceof IRGraph.IRInteger) {
        return true;
    };
    if (v instanceof IRGraph.IRDouble) {
        return true;
    };
    if (v instanceof IRGraph.IRBool) {
        return true;
    };
    if (v instanceof IRGraph.IRString) {
        return true;
    };
    if (v instanceof IRGraph.IRClass) {
        return true;
    };
    return false;
};
var renderUnionToGolang = function (ur) {
    var v = IRGraph.nullableFromUnion(ur);
    if (v instanceof Data_Maybe.Just) {
        return renderNullableToGolang(v.value0);
    };
    if (v instanceof Data_Maybe.Nothing) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(noComment)(Doc.lookupUnionName(ur));
    };
    throw new Error("Failed pattern match at Language.Golang line 74, column 5 - line 77, column 41: " + [ v.constructor.name ]);
};
var renderTypeToGolang = function (v) {
    if (v instanceof IRGraph.IRNoInformation) {
        return noComment("FIXME_THIS_SHOULD_NOT_HAPPEN");
    };
    if (v instanceof IRGraph.IRAnyType) {
        return noComment("interface{}");
    };
    if (v instanceof IRGraph.IRNull) {
        return noComment("interface{}");
    };
    if (v instanceof IRGraph.IRInteger) {
        return noComment("int64");
    };
    if (v instanceof IRGraph.IRDouble) {
        return noComment("float64");
    };
    if (v instanceof IRGraph.IRBool) {
        return noComment("bool");
    };
    if (v instanceof IRGraph.IRString) {
        return noComment("string");
    };
    if (v instanceof IRGraph.IRArray) {
        return Control_Bind.bind(Doc.bindDoc)(renderTypeToGolang(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)({
                rendered: "[]" + v1.rendered, 
                comment: Data_Functor.map(Data_Maybe.functorMaybe)(function (v2) {
                    return "array of " + v2;
                })(v1.comment)
            });
        });
    };
    if (v instanceof IRGraph.IRClass) {
        return Control_Bind.bindFlipped(Doc.bindDoc)(noComment)(Doc.lookupClassName(v.value0));
    };
    if (v instanceof IRGraph.IRMap) {
        return Control_Bind.bind(Doc.bindDoc)(renderTypeToGolang(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)({
                rendered: "map[string]" + v1.rendered, 
                comment: Data_Functor.map(Data_Maybe.functorMaybe)(function (v2) {
                    return "map to " + v2;
                })(v1.comment)
            });
        });
    };
    if (v instanceof IRGraph.IRUnion) {
        return renderUnionToGolang(v.value0);
    };
    throw new Error("Failed pattern match at Language.Golang line 80, column 22 - line 95, column 47: " + [ v.constructor.name ]);
};
var renderNullableToGolang = function (x) {
    return Control_Bind.bind(Doc.bindDoc)(renderTypeToGolang(x))(function (v) {
        return Control_Applicative.pure(Doc.applicativeDoc)((function () {
            var $55 = isValueType(x);
            if ($55) {
                return {
                    rendered: "*" + v.rendered, 
                    comment: Data_Maybe.Just.create(Data_Maybe.maybe("optional")(function (v1) {
                        return "optional " + v1;
                    })(v.comment))
                };
            };
            return {
                rendered: v.rendered, 
                comment: Data_Maybe.Nothing.value
            };
        })());
    });
};
var renderTopLevel = function (topLevelName) {
    return function (topLevelType) {
        return Control_Bind.bind(Doc.bindDoc)(renderTypeToGolang(topLevelType))(function (v) {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("type " + (topLevelName + (" " + (v.rendered + renderComment(v.comment))))))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("func Unmarshal" + (topLevelName + ("(data []byte) (" + (topLevelName + ", error) {")))))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("    var r " + topLevelName))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("    err := json.Unmarshal(data, &r)\x0a    return r, err\x0a}\x0a"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("func (r *" + (topLevelName + ") Marshal() ([]byte, error) {")))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.line("return json.Marshal(r)")))(function () {
                                        return Doc.line("}");
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    };
};
var goNameStyle = function ($101) {
    return Data_String_Util.startWithLetter(Data_String_Util.isLetterOrUnderscore)(true)(Data_String_Util.camelCase(legalize($101)));
};
var nameForClass = function (v) {
    return goNameStyle(Doc.combineNames(v.names));
};
var unionFieldName = function (t) {
    return Data_Functor.map(Doc.functorDoc)(goNameStyle)(Doc.getTypeNameForUnion(t));
};
var unionNameFromTypes = function (names) {
    return Data_Foldable.intercalate(Data_Foldable.foldableArray)(Data_Monoid.monoidString)("Or")(Data_Functor.mapFlipped(Data_Functor.functorArray)(names)(goNameStyle));
};
var compoundPredicates = [ IRGraph.unionHasArray, IRGraph.unionHasClass, IRGraph.unionHasMap ];
var columnize = function (v) {
    if (v instanceof Data_List_Types.Nil) {
        return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
    };
    if (v instanceof Data_List_Types.Cons) {
        var columnWidths = Data_Foldable.foldl(Data_List_Types.foldableList)(function (m) {
            return function (l) {
                return Data_List.zipWith(Data_Ord.max(Data_Ord.ordInt))(m)(Data_Functor.map(Data_List_Types.functorList)(Data_String.length)(l));
            };
        })(Data_Functor.map(Data_List_Types.functorList)(Data_String.length)(v.value0))(v.value1);
        var paddedRows = Data_Functor.map(Data_List_Types.functorList)(Data_List.zipWith(pad)(columnWidths))(v);
        return Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(paddedRows)(function (row) {
            return Doc.line(Data_String.trim(Data_Foldable.intercalate(Data_List_Types.foldableList)(Data_Monoid.monoidString)(" ")(row)));
        });
    };
    throw new Error("Failed pattern match at Language.Golang line 253, column 1 - line 253, column 44: " + [ v.constructor.name ]);
};
var renderStruct = function (name) {
    return function (columns) {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("type " + (name + " struct {")))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(columnize(columns)))(function () {
                return Doc.line("}");
            });
        });
    };
};
var renderGolangType = function (className) {
    return function (properties) {
        var propertyNames = Doc.transformPropertyNames(Doc.simpleNamer(Data_Ord.ordString)(goNameStyle))(function (v) {
            return "Other" + v;
        })([  ])(properties);
        var propsList = Utils.sortByKey(Data_Ord.ordString)(function (t) {
            return Doc.lookupName(Data_Ord.ordString)(Data_Tuple.fst(t))(propertyNames);
        })(Data_Map.toUnfoldable(Data_List_Types.unfoldableList)(properties));
        return Control_Bind.bind(Doc.bindDoc)(Utils.mapM(Doc.applicativeDoc)(Data_List_Types.traversableList)(function (v) {
            var csPropName = Doc.lookupName(Data_Ord.ordString)(v.value0)(propertyNames);
            return Control_Bind.bind(Doc.bindDoc)(renderTypeToGolang(v.value1))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)(new Data_List_Types.Cons(csPropName, new Data_List_Types.Cons(v1.rendered, new Data_List_Types.Cons("`json:\"" + (Data_String_Util.stringEscape(v.value0) + ("\"`" + renderComment(v1.comment))), Data_List_Types.Nil.value))));
            });
        })(propsList))(function (v) {
            return renderStruct(className)(v);
        });
    };
};
var renderGolangUnion = function (name) {
    return function (unionRep) {
        var predicateForType = function (t) {
            return function (ur) {
                var $73 = IRGraph.isUnionMember(t)(ur);
                if ($73) {
                    return new Data_Maybe.Just(t);
                };
                return Data_Maybe.Nothing.value;
            };
        };
        var memberArg = function (notPresentValue) {
            return function (renderPresent) {
                return function (p) {
                    var v = p(unionRep);
                    if (v instanceof Data_Maybe.Just) {
                        return Control_Bind.bind(Doc.bindDoc)(unionFieldName(v.value0))(function (v1) {
                            return Control_Applicative.pure(Doc.applicativeDoc)(renderPresent(v.value0)(v1));
                        });
                    };
                    if (v instanceof Data_Maybe.Nothing) {
                        return Control_Applicative.pure(Doc.applicativeDoc)(notPresentValue);
                    };
                    throw new Error("Failed pattern match at Language.Golang line 347, column 13 - line 351, column 44: " + [ v.constructor.name ]);
                };
            };
        };
        var primitiveMarshalArg = function (p) {
            return memberArg("nil")(function (v) {
                return function (n) {
                    return "x." + n;
                };
            })(p);
        };
        var primitiveUnmarshalArg = function (p) {
            return memberArg("nil")(function (v) {
                return function (n) {
                    return "&x." + n;
                };
            })(p);
        };
        var maybeAssignNil = function (p) {
            var v = p(unionRep);
            if (v instanceof Data_Maybe.Just) {
                return Control_Bind.bind(Doc.bindDoc)(unionFieldName(v.value0))(function (v1) {
                    return Doc.line("x." + (v1 + " = nil"));
                });
            };
            if (v instanceof Data_Maybe.Nothing) {
                return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
            };
            throw new Error("Failed pattern match at Language.Golang line 332, column 13 - line 336, column 33: " + [ v.constructor.name ]);
        };
        var makeArgs = function (primitive) {
            return function (compound) {
                return Control_Bind.bind(Doc.bindDoc)(Utils.mapM(Doc.applicativeDoc)(Data_Traversable.traversableArray)(primitive)(Data_Functor.map(Data_Functor.functorArray)(predicateForType)([ IRGraph.IRInteger.value, IRGraph.IRDouble.value, IRGraph.IRBool.value, IRGraph.IRString.value ])))(function (v) {
                    return Control_Bind.bind(Doc.bindDoc)(Utils.mapM(Doc.applicativeDoc)(Data_Traversable.traversableArray)(compound)(compoundPredicates))(function (v1) {
                        return Control_Applicative.pure(Doc.applicativeDoc)(Data_Foldable.intercalate(Data_Foldable.foldableArray)(Data_Monoid.monoidString)(", ")(Data_Array.concat([ v, v1 ])));
                    });
                });
            };
        };
        var ifClass = function (f) {
            var element = IRGraph.unionHasClass(unionRep);
            if (element instanceof Data_Maybe.Just) {
                return Control_Bind.bind(Doc.bindDoc)(unionFieldName(element.value0))(function (v) {
                    return Control_Bind.bind(Doc.bindDoc)(renderTypeToGolang(element.value0))(function (v1) {
                        return f(v)(v1.rendered);
                    });
                });
            };
            if (element instanceof Data_Maybe.Nothing) {
                return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
            };
            throw new Error("Failed pattern match at Language.Golang line 325, column 17 - line 330, column 37: " + [ element.constructor.name ]);
        };
        var compoundUnmarshalArg = function (p) {
            return memberArg("false, nil")(function (t) {
                return function (n) {
                    var $87 = IRGraph.isClass(t);
                    if ($87) {
                        return "true, &c";
                    };
                    return "true, &x." + n;
                };
            })(p);
        };
        var compoundMarshalArg = function (p) {
            return memberArg("false, nil")(function (t) {
                return function (n) {
                    return "x." + (n + (" != nil, x." + n));
                };
            })(p);
        };
        var v = IRGraph.removeNullFromUnion(unionRep);
        var isNullableString = (function () {
            if (v.hasNull) {
                return "true";
            };
            return "false";
        })();
        return Control_Bind.bind(Doc.bindDoc)(Utils.sortByKeyM(Data_Ord.ordString)(Doc.monadDoc)(unionFieldName)(IRGraph.unionToList(v.nonNullUnion)))(function (v1) {
            return Control_Bind.bind(Doc.bindDoc)(Utils.mapM(Doc.applicativeDoc)(Data_List_Types.traversableList)(function (t) {
                return Control_Bind.bind(Doc.bindDoc)(renderNullableToGolang(t))(function (v2) {
                    return Control_Bind.bind(Doc.bindDoc)(unionFieldName(t))(function (v3) {
                        return Control_Applicative.pure(Doc.applicativeDoc)(new Data_List_Types.Cons(v3, new Data_List_Types.Cons(v2.rendered + renderComment(v2.comment), Data_List_Types.Nil.value)));
                    });
                });
            })(v1))(function (v2) {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderStruct(name)(v2))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("func (x *" + (name + ") UnmarshalJSON(data []byte) error {")))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_Foldable.foldableArray)(compoundPredicates)(function (p) {
                                return maybeAssignNil(p);
                            }))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(ifClass(function (v3) {
                                    return function (typeString) {
                                        return Doc.line("var c " + typeString);
                                    };
                                }))(function () {
                                    return Control_Bind.bind(Doc.bindDoc)(makeArgs(primitiveUnmarshalArg)(compoundUnmarshalArg))(function (v3) {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("object, err := unmarshalUnion(data, " + (v3 + (", " + (isNullableString + ")")))))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if err != nil {"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.line("return err")))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if object {"))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(ifClass(function (name$prime) {
                                                                return function (v4) {
                                                                    return Doc.indent(Doc.line("x." + (name$prime + " = &c")));
                                                                };
                                                            }))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                                    return Doc.line("return nil");
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            })))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("func (x *" + (name + ") MarshalJSON() ([]byte, error) {")))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.bind(Doc.bindDoc)(makeArgs(primitiveMarshalArg)(compoundMarshalArg))(function (v3) {
                                                return Doc.line("return marshalUnion(" + (v3 + (", " + (isNullableString + ")"))));
                                            })))(function () {
                                                return Doc.line("}");
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    };
};
var golangDoc = Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// To parse and unparse this JSON data, add this code to your project and do:"))(function () {
    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(function (topLevelName) {
        return function (topLevelType) {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("//"))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("//    r, err := Unmarshal" + (topLevelName + "(bytes)")))(function () {
                    return Doc.line("//    bytes, err = r.Marshal()");
                });
            });
        };
    }))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("package main"))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                    return Control_Bind.bind(Doc.bindDoc)(Doc.getUnions)(function (v) {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.unless(Doc.applicativeDoc)(Data_Eq.eq(Data_List_Types.eqList(IRGraph.eqIRUnionRep))(v)(Data_List_Types.Nil.value))(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("import \"bytes\""))(function () {
                            return Doc.line("import \"errors\"");
                        })))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("import \"encoding/json\""))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.renderRenderItems(Doc.blank)(new Data_Maybe.Just(renderTopLevel))(renderGolangType)(new Data_Maybe.Just(renderGolangUnion)))(function () {
                                        return Control_Applicative.unless(Doc.applicativeDoc)(Data_Eq.eq(Data_List_Types.eqList(IRGraph.eqIRUnionRep))(v)(Data_List_Types.Nil.value))(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                            return Doc.line("func unmarshalUnion(data []byte, pi **int64, pf **float64, pb **bool, ps **string, haveArray bool, pa interface{}, haveObject bool, pc interface{}, haveMap bool, pm interface{}, nullable bool) (bool, error) {\x0a\x09if pi != nil {\x0a\x09\x09*pi = nil\x0a\x09}\x0a\x09if pf != nil {\x0a\x09\x09*pf = nil\x0a\x09}\x0a\x09if pb != nil {\x0a\x09\x09*pb = nil\x0a\x09}\x0a\x09if ps != nil {\x0a\x09\x09*ps = nil\x0a\x09}\x0a\x0a\x09dec := json.NewDecoder(bytes.NewReader(data))\x0a\x09dec.UseNumber()\x0a\x09tok, err := dec.Token()\x0a\x09if err != nil {\x0a\x09\x09return false, err\x0a\x09}\x0a\x0a\x09switch v := tok.(type) {\x0a\x09case json.Number:\x0a\x09\x09if pi != nil {\x0a\x09\x09\x09i, err := v.Int64()\x0a\x09\x09\x09if err == nil {\x0a\x09\x09\x09\x09*pi = &i\x0a\x09\x09\x09\x09return false, nil\x0a\x09\x09\x09}\x0a\x09\x09}\x0a\x09\x09if pf != nil {\x0a\x09\x09\x09f, err := v.Float64()\x0a\x09\x09\x09if err == nil {\x0a\x09\x09\x09\x09*pf = &f\x0a\x09\x09\x09\x09return false, nil\x0a\x09\x09\x09}\x0a\x09\x09\x09return false, errors.New(\"Unparsable number\")\x0a\x09\x09}\x0a\x09\x09return false, errors.New(\"Union does not contain number\")\x0a\x09case float64:\x0a\x09\x09return false, errors.New(\"Decoder should not return float64\")\x0a\x09case bool:\x0a\x09\x09if pb != nil {\x0a\x09\x09\x09*pb = &v\x0a\x09\x09\x09return false, nil\x0a\x09\x09}\x0a\x09\x09return false, errors.New(\"Union does not contain bool\")\x0a\x09case string:\x0a\x09\x09if ps != nil {\x0a\x09\x09\x09*ps = &v\x0a\x09\x09\x09return false, nil\x0a\x09\x09}\x0a\x09\x09return false, errors.New(\"Union does not contain string\")\x0a\x09case nil:\x0a\x09\x09if nullable {\x0a\x09\x09\x09return false, nil\x0a\x09\x09}\x0a\x09\x09return false, errors.New(\"Union does not contain null\")\x0a\x09case json.Delim:\x0a\x09\x09if v == '{' {\x0a\x09\x09\x09if haveObject {\x0a\x09\x09\x09\x09return true, json.Unmarshal(data, pc)\x0a\x09\x09\x09}\x0a\x09\x09\x09if haveMap {\x0a\x09\x09\x09\x09return false, json.Unmarshal(data, pm)\x0a\x09\x09\x09}\x0a\x09\x09\x09return false, errors.New(\"Union does not contain object\")\x0a\x09\x09}\x0a\x09\x09if v == '[' {\x0a\x09\x09\x09if haveArray {\x0a\x09\x09\x09\x09return false, json.Unmarshal(data, pa)\x0a\x09\x09\x09}\x0a\x09\x09\x09return false, errors.New(\"Union does not contain array\")\x0a\x09\x09}\x0a\x09\x09return false, errors.New(\"Cannot handle delimiter\")\x0a\x09}\x0a\x09return false, errors.New(\"Cannot unmarshal union\")\x0a\x0a}\x0a\x0afunc marshalUnion(pi *int64, pf *float64, pb *bool, ps *string, haveArray bool, pa interface{}, haveObject bool, pc interface{}, haveMap bool, pm interface{}, nullable bool) ([]byte, error) {\x0a\x09if pi != nil {\x0a\x09\x09return json.Marshal(*pi)\x0a\x09}\x0a\x09if pf != nil {\x0a\x09\x09return json.Marshal(*pf)\x0a\x09}\x0a\x09if pb != nil {\x0a\x09\x09return json.Marshal(*pb)\x0a\x09}\x0a\x09if ps != nil {\x0a\x09\x09return json.Marshal(*ps)\x0a\x09}\x0a\x09if haveArray {\x0a\x09\x09return json.Marshal(pa)\x0a\x09}\x0a\x09if haveObject {\x0a\x09\x09return json.Marshal(pc)\x0a\x09}\x0a\x09if haveMap {\x0a\x09\x09return json.Marshal(pm)\x0a\x09}\x0a\x09if nullable {\x0a\x09\x09return json.Marshal(nil)\x0a\x09}\x0a\x09return nil, errors.New(\"Union must not be null\")\x0a}");
                                        }));
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
});
var renderer = {
    displayName: "Go", 
    names: [ "go", "golang" ], 
    aceMode: "golang", 
    extension: "go", 
    doc: golangDoc, 
    options: [  ], 
    transforms: {
        nameForClass: Doc.simpleNamer(IRGraph.ordIRClassData)(nameForClass), 
        nextName: function (s) {
            return "Other" + s;
        }, 
        forbiddenNames: [  ], 
        topLevelName: Doc.forbidNamer(Data_Ord.ordString)(goNameStyle)(function (n) {
            var gn = goNameStyle(n);
            return [ gn, "Unmarshal" + gn ];
        }), 
        unions: new Data_Maybe.Just({
            predicate: Doc.unionIsNotSimpleNullable, 
            properName: Doc.simpleNamer(IRGraph.ordNamed(Data_Set.ordSet(Data_Ord.ordString)))(function ($102) {
                return goNameStyle(Doc.combineNames($102));
            }), 
            nameFromTypes: Doc.simpleNamer(Data_Ord.ordArray(Data_Ord.ordString))(unionNameFromTypes)
        })
    }
};
module.exports = {
    renderer: renderer
};
//# sourceMappingURL=index.js.map
