// Generated by purs version 0.11.6
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Char_Unicode = require("../Data.Char.Unicode");
var Data_Eq = require("../Data.Eq");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_Map = require("../Data.Map");
var Data_Maybe = require("../Data.Maybe");
var Data_Ord = require("../Data.Ord");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Set = require("../Data.Set");
var Data_String_Util = require("../Data.String.Util");
var Data_Unit = require("../Data.Unit");
var Doc = require("../Doc");
var IRGraph = require("../IRGraph");
var Prelude = require("../Prelude");
var tokenCase = function (tokenType) {
    return Doc.line("case " + (tokenType + ":"));
};
var renderUnionWithTypeRenderer = function (typeRenderer) {
    return function (ur) {
        var v = IRGraph.nullableFromUnion(ur);
        if (v instanceof Data_Maybe.Just) {
            return typeRenderer(true)(v.value0);
        };
        if (v instanceof Data_Maybe.Nothing) {
            return Doc.lookupUnionName(ur);
        };
        throw new Error("Failed pattern match at Language.Java line 82, column 5 - line 84, column 34: " + [ v.constructor.name ]);
    };
};
var renderType = function (reference) {
    return function (v) {
        if (v instanceof IRGraph.IRNoInformation) {
            return Control_Applicative.pure(Doc.applicativeDoc)("FIXME_THIS_SHOULD_NOT_HAPPEN");
        };
        if (v instanceof IRGraph.IRAnyType) {
            return Control_Applicative.pure(Doc.applicativeDoc)("Object");
        };
        if (v instanceof IRGraph.IRNull) {
            return Control_Applicative.pure(Doc.applicativeDoc)("Object");
        };
        if (v instanceof IRGraph.IRInteger) {
            return Control_Applicative.pure(Doc.applicativeDoc)((function () {
                if (reference) {
                    return "Long";
                };
                return "long";
            })());
        };
        if (v instanceof IRGraph.IRDouble) {
            return Control_Applicative.pure(Doc.applicativeDoc)((function () {
                if (reference) {
                    return "Double";
                };
                return "double";
            })());
        };
        if (v instanceof IRGraph.IRBool) {
            return Control_Applicative.pure(Doc.applicativeDoc)((function () {
                if (reference) {
                    return "Boolean";
                };
                return "boolean";
            })());
        };
        if (v instanceof IRGraph.IRString) {
            return Control_Applicative.pure(Doc.applicativeDoc)("String");
        };
        if (v instanceof IRGraph.IRArray) {
            return Control_Bind.bind(Doc.bindDoc)(renderType(false)(v.value0))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)(v1 + "[]");
            });
        };
        if (v instanceof IRGraph.IRClass) {
            return Doc.lookupClassName(v.value0);
        };
        if (v instanceof IRGraph.IRMap) {
            return Control_Bind.bind(Doc.bindDoc)(renderType(true)(v.value0))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)("Map<String, " + (v1 + ">"));
            });
        };
        if (v instanceof IRGraph.IRUnion) {
            return renderUnionWithTypeRenderer(renderType)(v.value0);
        };
        throw new Error("Failed pattern match at Language.Java line 87, column 24 - line 102, column 60: " + [ v.constructor.name ]);
    };
};
var renderTypeWithoutGenerics = function (reference) {
    return function (v) {
        if (v instanceof IRGraph.IRArray) {
            return Control_Bind.bind(Doc.bindDoc)(renderTypeWithoutGenerics(false)(v.value0))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)(v1 + "[]");
            });
        };
        if (v instanceof IRGraph.IRMap) {
            return Control_Applicative.pure(Doc.applicativeDoc)("Map");
        };
        if (v instanceof IRGraph.IRUnion) {
            return renderUnionWithTypeRenderer(renderTypeWithoutGenerics)(v.value0);
        };
        return renderType(reference)(v);
    };
};
var renderPackageAndImports = function (imports) {
    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("package io.quicktype;"))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
            return Data_Foldable.for_(Doc.applicativeDoc)(Data_Foldable.foldableArray)(imports)(function ($$package) {
                return Doc.line("import " + ($$package + ";"));
            });
        });
    });
};
var renderNullCase = Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(tokenCase("VALUE_NULL"))(function () {
    return Doc.indent(Doc.line("break;"));
});
var renderFileComment = function (fileName) {
    return Doc.line("// " + (fileName + ".java"));
};
var renderFileHeader = function (fileName) {
    return function (imports) {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderFileComment(fileName))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPackageAndImports(imports))(function () {
                    return Doc.blank;
                });
            });
        });
    };
};
var renderConverter = (function () {
    var getMethodName = function (prefix) {
        return function (suffix) {
            return function (topLevelName) {
                return Doc.getForSingleOrMultipleTopLevels(prefix + suffix)(prefix + (Data_String_Util.capitalize(topLevelName) + suffix));
            };
        };
    };
    var getReaderGetterName = getMethodName("get")("ObjectReader");
    var getWriterGetterName = getMethodName("get")("ObjectWriter");
    var getFieldOrMethodName = function (methodName) {
        return function (topLevelName) {
            return Doc.getForSingleOrMultipleTopLevels(methodName)(topLevelName + Data_String_Util.capitalize(methodName));
        };
    };
    var getEncoderName = getFieldOrMethodName("toJsonString");
    var getDecoderName = getFieldOrMethodName("fromJsonString");
    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderFileComment("Converter"))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// To use this code, add the following Maven dependency to your project:\x0a//\x0a//     com.fasterxml.jackson.core : jackson-databind : 2.9.0\x0a//\x0a// Import this package:\x0a//\x0a//     import io.quicktype.Converter;\x0a//\x0a// Then you can deserialize a JSON string with\x0a//"))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(function (topLevelName) {
                    return function (topLevelType) {
                        return Control_Bind.bind(Doc.bindDoc)(renderType(false)(topLevelType))(function (v) {
                            return Control_Bind.bind(Doc.bindDoc)(getDecoderName(topLevelName))(function (v1) {
                                return Doc.line("//     " + (v + (" data = Converter." + (v1 + "(jsonString);"))));
                            });
                        });
                    };
                }))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPackageAndImports([ "java.util.Map", "java.io.IOException", "com.fasterxml.jackson.databind.*", "com.fasterxml.jackson.core.JsonProcessingException" ]))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public class Converter {"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// Serialize/deserialize helpers"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(function (topLevelName) {
                                            return function (topLevelType) {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                    return Control_Bind.bind(Doc.bindDoc)(renderType(false)(topLevelType))(function (v) {
                                                        return Control_Bind.bind(Doc.bindDoc)(getDecoderName(topLevelName))(function (v1) {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public static " + (v + (" " + (v1 + "(String json) throws IOException {")))))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.bind(Doc.bindDoc)(getReaderGetterName(topLevelName))(function (v2) {
                                                                    return Doc.line("return " + (v2 + "().readValue(json);"));
                                                                })))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                            return Control_Bind.bind(Doc.bindDoc)(getEncoderName(topLevelName))(function (v2) {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public static String " + (v2 + ("(" + (v + " obj) throws JsonProcessingException {")))))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.bind(Doc.bindDoc)(getWriterGetterName(topLevelName))(function (v3) {
                                                                                        return Doc.line("return " + (v3 + "().writeValueAsString(obj);"));
                                                                                    })))(function () {
                                                                                        return Doc.line("}");
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            };
                                        }))(function () {
                                            return Doc.forEachTopLevel_(function (topLevelName) {
                                                return function (topLevelType) {
                                                    return Control_Bind.bind(Doc.bindDoc)(getFieldOrMethodName("reader")(topLevelName))(function (v) {
                                                        return Control_Bind.bind(Doc.bindDoc)(getFieldOrMethodName("writer")(topLevelName))(function (v1) {
                                                            return Control_Bind.bind(Doc.bindDoc)(getMethodName("instantiate")("Mapper")(topLevelName))(function (v2) {
                                                                return Control_Bind.bind(Doc.bindDoc)(getReaderGetterName(topLevelName))(function (v3) {
                                                                    return Control_Bind.bind(Doc.bindDoc)(getWriterGetterName(topLevelName))(function (v4) {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("private static ObjectReader " + (v + ";")))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("private static ObjectWriter " + (v1 + ";")))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("private static void " + (v2 + "() {")))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.bind(Doc.bindDoc)(renderTypeWithoutGenerics(false)(topLevelType))(function (v5) {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("ObjectMapper mapper = new ObjectMapper();"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(v + (" = mapper.reader(" + (v5 + ".class);"))))(function () {
                                                                                                        return Doc.line(v1 + (" = mapper.writerFor(" + (v5 + ".class);")));
                                                                                                    });
                                                                                                });
                                                                                            })))(function () {
                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("private static ObjectReader " + (v3 + "() {")))(function () {
                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if (" + (v + " == null) instantiateMapper();")))(function () {
                                                                                                                return Doc.line("return " + (v + ";"));
                                                                                                            })))(function () {
                                                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("private static ObjectWriter " + (v4 + "() {")))(function () {
                                                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if (" + (v1 + " == null) instantiateMapper();")))(function () {
                                                                                                                                return Doc.line("return " + (v1 + ";"));
                                                                                                                            })))(function () {
                                                                                                                                return Doc.line("}");
                                                                                                                            });
                                                                                                                        });
                                                                                                                    });
                                                                                                                });
                                                                                                            });
                                                                                                        });
                                                                                                    });
                                                                                                });
                                                                                            });
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                };
                                            });
                                        });
                                    })))(function () {
                                        return Doc.line("}");
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
})();
var isStartCharacter = function (c) {
    return Data_Char_Unicode.isAscii(c) && Data_Char_Unicode.isLetter(c) || c === "_";
};
var isPartCharacter = function (c) {
    return isStartCharacter(c) || Data_Char_Unicode.isAscii(c) && Data_Char_Unicode.isDigit(c);
};
var legalize = Data_String_Util.legalizeCharacters(isPartCharacter);
var javaNameStyle = function (upper) {
    return function ($81) {
        return Data_String_Util.startWithLetter(isStartCharacter)(upper)(Data_String_Util.camelCase(legalize($81)));
    };
};
var nameForClass = function (v) {
    return javaNameStyle(true)(Doc.combineNames(v.names));
};
var renderUnionField = function (t) {
    return Control_Bind.bind(Doc.bindDoc)(renderType(true)(t))(function (v) {
        return Control_Bind.bind(Doc.bindDoc)(Data_Functor.map(Doc.functorDoc)(Data_Functor.map(Data_Functor.functorFn)(javaNameStyle(false))(function (v1) {
            return v1 + "_value";
        }))(Doc.getTypeNameForUnion(t)))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)({
                renderedType: v, 
                fieldName: v1
            });
        });
    });
};
var forbiddenNames = [ "Object", "Class", "System", "Long", "Double", "Boolean", "String", "Map", "Exception", "IOException", "JsonProperty", "JsonDeserialize", "JsonDeserializer", "JsonSerialize", "JsonSerializer", "JsonParser", "JsonProcessingException", "DeserializationContext", "SerializerProvider", "Converter", "abstract", "continue", "for", "new", "switch", "assert", "default", "goto", "package", "synchronized", "boolean", "do", "if", "private", "this", "break", "double", "implements", "protected", "throw", "byte", "else", "import", "public", "throws", "case", "enum", "instanceof", "return", "transient", "catch", "extends", "int", "short", "try", "char", "final", "interface", "static", "void", "class", "finally", "long", "strictfp", "volatile", "const", "float", "native", "super", "while", "null", "false", "true" ];
var renderClassDefinition = function (className) {
    return function (properties) {
        var forEachProp_ = function (properties$prime) {
            return function (propertyNames) {
                return function (f) {
                    return Doc.forEachProperty_(properties$prime)(propertyNames)(function (pname) {
                        return function (ptype) {
                            return function (fieldName) {
                                return function (v) {
                                    var javaName = Data_String_Util.capitalize(fieldName);
                                    return Control_Bind.bind(Doc.bindDoc)(renderType(false)(ptype))(function (v1) {
                                        return f(pname)(javaName)(fieldName)(v1);
                                    });
                                };
                            };
                        };
                    });
                };
            };
        };
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderFileHeader(className)([ "java.util.Map", "com.fasterxml.jackson.annotation.*" ]))(function () {
            var propertyNames = Doc.transformPropertyNames(Doc.simpleNamer(Data_Ord.ordString)(javaNameStyle(false)))(function (n) {
                return "other" + Data_String_Util.capitalize(n);
            })(forbiddenNames)(properties);
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Map.isEmpty(properties))(Doc.line("@JsonAutoDetect(fieldVisibility=JsonAutoDetect.Visibility.NONE)")))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public class " + (className + " {")))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(forEachProp_(properties)(propertyNames)(function (v) {
                        return function (javaName) {
                            return function (fieldName) {
                                return function (rendered) {
                                    return Doc.line("private " + (rendered + (" " + (fieldName + ";"))));
                                };
                            };
                        };
                    }))(function () {
                        return forEachProp_(properties)(propertyNames)(function (pname) {
                            return function (javaName) {
                                return function (fieldName) {
                                    return function (rendered) {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("@JsonProperty(\"" + (Data_String_Util.stringEscape(pname) + "\")")))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public " + (rendered + (" get" + (javaName + ("() { return " + (fieldName + "; }")))))))(function () {
                                                    return Doc.line("public void set" + (javaName + ("(" + (rendered + (" value) { this." + (fieldName + " = value; }"))))));
                                                });
                                            });
                                        });
                                    };
                                };
                            };
                        });
                    })))(function () {
                        return Doc.line("}");
                    });
                });
            });
        });
    };
};
var deserializeType = function (t) {
    return Control_Bind.bind(Doc.bindDoc)(renderUnionField(t))(function (v) {
        return Control_Bind.bind(Doc.bindDoc)(renderTypeWithoutGenerics(true)(t))(function (v1) {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("value." + (v.fieldName + (" = jsonParser.readValueAs(" + (v1 + ".class);")))))(function () {
                return Doc.line("break;");
            });
        });
    });
};
var renderDoubleCase = function (union) {
    return Control_Applicative.when(Doc.applicativeDoc)(IRGraph.isUnionMember(IRGraph.IRDouble.value)(union))(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.unless(Doc.applicativeDoc)(IRGraph.isUnionMember(IRGraph.IRInteger.value)(union))(tokenCase("VALUE_NUMBER_INT")))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(tokenCase("VALUE_NUMBER_FLOAT"))(function () {
            return Doc.indent(deserializeType(IRGraph.IRDouble.value));
        });
    }));
};
var renderGenericCase = function (predicate) {
    return function (tokenType) {
        return function (union) {
            var v = predicate(union);
            if (v instanceof Data_Maybe.Nothing) {
                return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
            };
            if (v instanceof Data_Maybe.Just) {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(tokenCase(tokenType))(function () {
                    return Doc.indent(deserializeType(v.value0));
                });
            };
            throw new Error("Failed pattern match at Language.Java line 281, column 5 - line 286, column 30: " + [ v.constructor.name ]);
        };
    };
};
var renderPrimitiveCase = function (tokenTypes) {
    return function (t) {
        return function (union) {
            return Control_Applicative.when(Doc.applicativeDoc)(IRGraph.isUnionMember(t)(union))(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_Foldable.foldableArray)(tokenTypes)(function (tokenType) {
                return tokenCase(tokenType);
            }))(function () {
                return Doc.indent(deserializeType(t));
            }));
        };
    };
};
var renderUnionDefinition = function (unionName) {
    return function (unionRep) {
        var v = IRGraph.removeNullFromUnion(unionRep);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderFileHeader(unionName)([ "java.io.IOException", "java.util.Map", "com.fasterxml.jackson.core.*", "com.fasterxml.jackson.databind.*", "com.fasterxml.jackson.databind.annotation.*" ]))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("@JsonDeserialize(using = " + (unionName + ".Deserializer.class)")))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("@JsonSerialize(using = " + (unionName + ".Serializer.class)")))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public class " + (unionName + " {")))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(IRGraph.forUnion_(Doc.monadDoc)(v.nonNullUnion)(function (t) {
                            return Control_Bind.bind(Doc.bindDoc)(renderUnionField(t))(function (v1) {
                                return Doc.line("public " + (v1.renderedType + (" " + (v1.fieldName + ";"))));
                            });
                        }))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("static class Deserializer extends JsonDeserializer<" + (unionName + "> {")))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("@Override"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public " + (unionName + " deserialize(JsonParser jsonParser, DeserializationContext deserializationContext) throws IOException, JsonProcessingException {")))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(unionName + (" value = new " + (unionName + "();"))))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("switch (jsonParser.getCurrentToken()) {"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(v.hasNull)(renderNullCase))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPrimitiveCase([ "VALUE_NUMBER_INT" ])(IRGraph.IRInteger.value)(v.nonNullUnion))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderDoubleCase(v.nonNullUnion))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPrimitiveCase([ "VALUE_TRUE", "VALUE_FALSE" ])(IRGraph.IRBool.value)(v.nonNullUnion))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPrimitiveCase([ "VALUE_STRING" ])(IRGraph.IRString.value)(v.nonNullUnion))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderGenericCase(IRGraph.unionHasArray)("START_ARRAY")(v.nonNullUnion))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderGenericCase(IRGraph.unionHasClass)("START_OBJECT")(v.nonNullUnion))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderGenericCase(IRGraph.unionHasMap)("START_OBJECT")(v.nonNullUnion))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("default: throw new IOException(\"Cannot deserialize " + (unionName + "\");")))(function () {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                                                            return Doc.line("return value;");
                                                                                        });
                                                                                    });
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            })))(function () {
                                                return Doc.line("}");
                                            });
                                        });
                                    })))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("static class Serializer extends JsonSerializer<" + (unionName + "> {")))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("@Override"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public void serialize(" + (unionName + " obj, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException {")))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(IRGraph.forUnion_(Doc.monadDoc)(v.nonNullUnion)(function (field) {
                                                                return Control_Bind.bind(Doc.bindDoc)(renderUnionField(field))(function (v1) {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if (obj." + (v1.fieldName + " != null) {")))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("jsonGenerator.writeObject(obj." + (v1.fieldName + ");")))(function () {
                                                                            return Doc.line("return;");
                                                                        })))(function () {
                                                                            return Doc.line("}");
                                                                        });
                                                                    });
                                                                });
                                                            }))(function () {
                                                                if (v.hasNull) {
                                                                    return Doc.line("jsonGenerator.writeNull();");
                                                                };
                                                                return Doc.line("throw new IOException(\"" + (unionName + " must not be null\");"));
                                                            })))(function () {
                                                                return Doc.line("}");
                                                            });
                                                        });
                                                    })))(function () {
                                                        return Doc.line("}");
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        })))(function () {
                            return Doc.line("}");
                        });
                    });
                });
            });
        });
    };
};
var javaDoc = Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderConverter)(function () {
    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
        return Doc.renderRenderItems(Doc.blank)(Data_Maybe.Nothing.value)(renderClassDefinition)(new Data_Maybe.Just(renderUnionDefinition));
    });
});
var renderer = {
    displayName: "Java", 
    names: [ "java" ], 
    aceMode: "java", 
    extension: "java", 
    doc: javaDoc, 
    options: [  ], 
    transforms: {
        nameForClass: Doc.simpleNamer(IRGraph.ordIRClassData)(nameForClass), 
        nextName: function (s) {
            return "Other" + s;
        }, 
        forbiddenNames: forbiddenNames, 
        topLevelName: Doc.noForbidNamer(Data_Ord.ordString)(javaNameStyle(true)), 
        unions: new Data_Maybe.Just({
            predicate: Doc.unionIsNotSimpleNullable, 
            properName: Doc.simpleNamer(IRGraph.ordNamed(Data_Set.ordSet(Data_Ord.ordString)))(function ($82) {
                return javaNameStyle(true)(Doc.combineNames($82));
            }), 
            nameFromTypes: Doc.simpleNamer(Data_Ord.ordArray(Data_Ord.ordString))(Doc.unionNameIntercalated(javaNameStyle(true))("Or"))
        })
    }
};
module.exports = {
    renderer: renderer
};
//# sourceMappingURL=index.js.map
