// Generated by purs version 0.11.6
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Category = require("../Control.Category");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Bifunctor = require("../Data.Bifunctor");
var Data_Char_Unicode = require("../Data.Char.Unicode");
var Data_Eq = require("../Data.Eq");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_List_Types = require("../Data.List.Types");
var Data_Map = require("../Data.Map");
var Data_Maybe = require("../Data.Maybe");
var Data_Monoid = require("../Data.Monoid");
var Data_Ord = require("../Data.Ord");
var Data_Ring = require("../Data.Ring");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Semiring = require("../Data.Semiring");
var Data_String = require("../Data.String");
var Data_String_Util = require("../Data.String.Util");
var Data_Tuple = require("../Data.Tuple");
var Data_Unfoldable = require("../Data.Unfoldable");
var Doc = require("../Doc");
var IRGraph = require("../IRGraph");
var Prelude = require("../Prelude");
var propertyNameify = function (v) {
    if (v === "") {
        return "\"\"";
    };
    if (Data_String.contains(" ")(v)) {
        return "\"" + (v + "\"");
    };
    return v;
};
var isStartCharacter = function (c) {
    return Data_String_Util.isLetterOrLetterNumber(c) || c === "_";
};
var isPartCharacter = function (c) {
    var v = Data_Char_Unicode.generalCategory(c);
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.DecimalNumber) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.ConnectorPunctuation) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.NonSpacingMark) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.SpacingCombiningMark) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.Format) {
        return true;
    };
    return isStartCharacter(c);
};
var legalize = Data_String_Util.legalizeCharacters(isPartCharacter);
var isComplex = function ($copy_v) {
    var $tco_done = false;
    var $tco_result;
    function $tco_loop(v) {
        if (v instanceof IRGraph.IRArray) {
            $copy_v = v.value0;
            return;
        };
        if (v instanceof IRGraph.IRMap) {
            $tco_done = true;
            return true;
        };
        if (v instanceof IRGraph.IRUnion) {
            $tco_done = true;
            return true;
        };
        $tco_done = true;
        return false;
    };
    while (!$tco_done) {
        $tco_result = $tco_loop($copy_v);
    };
    return $tco_result;
};
var renderUnion = function (ur) {
    var v = IRGraph.nullableFromUnion(ur);
    if (v instanceof Data_Maybe.Just) {
        return renderType(v.value0);
    };
    if (v instanceof Data_Maybe.Nothing) {
        return Control_Bind.bind(Doc.bindDoc)(IRGraph.mapUnionM(Doc.monadDoc)(renderType)(ur))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)(Data_Foldable.intercalate(Data_List_Types.foldableList)(Data_Monoid.monoidString)(" | ")(v1));
        });
    };
    throw new Error("Failed pattern match at Language.SimpleTypes line 61, column 5 - line 65, column 39: " + [ v.constructor.name ]);
};
var renderType = function (v) {
    if (v instanceof IRGraph.IRNoInformation) {
        return Control_Applicative.pure(Doc.applicativeDoc)("FIXME_THIS_SHOULD_NOT_HAPPEN");
    };
    if (v instanceof IRGraph.IRAnyType) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Any");
    };
    if (v instanceof IRGraph.IRNull) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Null");
    };
    if (v instanceof IRGraph.IRInteger) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Integer");
    };
    if (v instanceof IRGraph.IRDouble) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Double");
    };
    if (v instanceof IRGraph.IRBool) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Boolean");
    };
    if (v instanceof IRGraph.IRString) {
        return Control_Applicative.pure(Doc.applicativeDoc)("String");
    };
    if (v instanceof IRGraph.IRClass) {
        return Doc.lookupClassName(v.value0);
    };
    if (v instanceof IRGraph.IRArray && isComplex(v.value0)) {
        return Control_Bind.bind(Doc.bindDoc)(renderType(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)("Array<" + (v1 + ">"));
        });
    };
    if (v instanceof IRGraph.IRArray) {
        return Control_Bind.bind(Doc.bindDoc)(renderType(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)(v1 + "[]");
        });
    };
    if (v instanceof IRGraph.IRMap) {
        return Control_Bind.bind(Doc.bindDoc)(renderType(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)("Map<String, " + (v1 + ">"));
        });
    };
    if (v instanceof IRGraph.IRUnion) {
        var v1 = IRGraph.nullableFromUnion(v.value0);
        if (v1 instanceof Data_Maybe.Nothing) {
            return renderUnion(v.value0);
        };
        if (v1 instanceof Data_Maybe.Just) {
            return Control_Bind.bind(Doc.bindDoc)(renderType(v1.value0))(function (v2) {
                return Control_Applicative.pure(Doc.applicativeDoc)("Maybe<" + (v2 + ">"));
            });
        };
        throw new Error("Failed pattern match at Language.SimpleTypes line 91, column 9 - line 97, column 1: " + [ v1.constructor.name ]);
    };
    throw new Error("Failed pattern match at Language.SimpleTypes line 68, column 14 - line 97, column 1: " + [ v.constructor.name ]);
};
var renderClass = function (className) {
    return function (properties) {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("class " + (className + " {")))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent((function () {
                var props = Data_Map.toUnfoldable(Data_Unfoldable.unfoldableArray)(properties);
                var propsClean = Data_Functor.map(Data_Functor.functorArray)(Data_Bifunctor.bimap(Data_Tuple.bifunctorTuple)(propertyNameify)(Control_Category.id(Control_Category.categoryFn)))(props);
                var maxWidth = Data_Foldable.maximum(Data_Ord.ordInt)(Data_Foldable.foldableArray)(Data_Functor.mapFlipped(Data_Functor.functorArray)(Data_Functor.mapFlipped(Data_Functor.functorArray)(propsClean)(Data_Tuple.fst))(Data_String.length));
                return Data_Foldable.for_(Doc.applicativeDoc)(Data_Foldable.foldableArray)(propsClean)(function (v) {
                    var indent = Data_Maybe.maybe(1)(function (w) {
                        return (w - Data_String.length(v.value0) | 0) + 1 | 0;
                    })(maxWidth);
                    return Control_Bind.bind(Doc.bindDoc)(renderType(v.value1))(function (v1) {
                        return Doc.line(v.value0 + (":" + (Data_String_Util.times(" ")(indent) + v1)));
                    });
                });
            })()))(function () {
                return Doc.line("}");
            });
        });
    };
};
var pseudocodeDoc = Doc.renderRenderItems(Doc.blank)(Data_Maybe.Nothing.value)(renderClass)(Data_Maybe.Nothing.value);
var classNameStyle = function (upper) {
    return function ($46) {
        return Data_String_Util.startWithLetter(isStartCharacter)(upper)(Data_String_Util.camelCase(legalize($46)));
    };
};
var upperNameStyle = classNameStyle(true);
var nameForClass = function (v) {
    return upperNameStyle(Doc.combineNames(v.names));
};
var renderer = {
    displayName: "Simple Types", 
    names: [ "types" ], 
    aceMode: "groovy", 
    extension: "types", 
    doc: pseudocodeDoc, 
    options: [  ], 
    transforms: {
        nameForClass: Doc.noForbidNamer(IRGraph.ordIRClassData)(nameForClass), 
        nextName: function (s) {
            return "Other" + s;
        }, 
        forbiddenNames: [  ], 
        topLevelName: Doc.simpleNamer(Data_Ord.ordString)(Control_Category.id(Control_Category.categoryFn)), 
        unions: Data_Maybe.Nothing.value
    }
};
module.exports = {
    renderer: renderer
};
//# sourceMappingURL=index.js.map
