// Generated by purs version 0.11.6
"use strict";
var Data_Array = require("../Data.Array");
var Data_Eq = require("../Data.Eq");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_JSON_AST = require("../Data.JSON.AST");
var Data_Maybe = require("../Data.Maybe");
var Data_Monoid = require("../Data.Monoid");
var Data_StrMap = require("../Data.StrMap");
var Data_String = require("../Data.String");
var Data_Tuple = require("../Data.Tuple");
var Partial_Unsafe = require("../Partial.Unsafe");
var Prelude = require("../Prelude");
var BooleanValue = (function () {
    function BooleanValue(value0) {
        this.value0 = value0;
    };
    BooleanValue.create = function (value0) {
        return new BooleanValue(value0);
    };
    return BooleanValue;
})();
var EnumValue = (function () {
    function EnumValue(value0, value1) {
        this.value0 = value0;
        this.value1 = value1;
    };
    EnumValue.create = function (value0) {
        return function (value1) {
            return new EnumValue(value0, value1);
        };
    };
    return EnumValue;
})();
var makeOptionValues = function (optionSpecifications) {
    return function (optionStrings) {
        var specMap = Data_StrMap.fromFoldable(Data_Foldable.foldableArray)(Data_Functor.map(Data_Functor.functorArray)(function (spec) {
            return new Data_Tuple.Tuple(spec.name, spec);
        })(optionSpecifications));
        var makeOptionValue = function (name) {
            return function (optionString) {
                var spec = Data_Maybe.fromJust()(Data_StrMap.lookup(name)(specMap));
                if (spec["default"] instanceof BooleanValue) {
                    var l = Data_String.toLower(optionString);
                    return BooleanValue.create(!Data_Foldable.elem(Data_Foldable.foldableArray)(Data_Eq.eqString)(l)([ "false", "f", "no", "n", "0" ]));
                };
                if (spec["default"] instanceof EnumValue) {
                    var v = Data_Array.findIndex(Data_Eq.eq(Data_Eq.eqString)(optionString))(spec["default"].value1);
                    if (v instanceof Data_Maybe.Just) {
                        return new EnumValue(v.value0, spec["default"].value1);
                    };
                    if (v instanceof Data_Maybe.Nothing) {
                        return new EnumValue(0, spec["default"].value1);
                    };
                    throw new Error("Failed pattern match at Options line 71, column 21 - line 73, column 49: " + [ v.constructor.name ]);
                };
                throw new Error("Failed pattern match at Options line 66, column 17 - line 73, column 49: " + [ spec["default"].constructor.name ]);
            };
        };
        var isValidOption = function (optionName) {
            return function (value) {
                return Data_StrMap.member(optionName)(specMap);
            };
        };
        var validOptions = Data_StrMap.filterWithKey(isValidOption)(optionStrings);
        return Data_StrMap.mapWithKey(makeOptionValue)(validOptions);
    };
};
var lookupOptionValue = function (v) {
    return function (optionValues) {
        var v1 = Data_StrMap.lookup(v.specification.name)(optionValues);
        if (v1 instanceof Data_Maybe.Nothing) {
            return v.extractor(v["specification"]["default"]);
        };
        if (v1 instanceof Data_Maybe.Just) {
            return v.extractor(v1.value0);
        };
        throw new Error("Failed pattern match at Options line 109, column 5 - line 111, column 25: " + [ v1.constructor.name ]);
    };
};
var enumOption = function (name) {
    return function (description) {
        return function (cases) {
            var caseNames = Data_Functor.map(Data_Functor.functorArray)(Data_Tuple.fst)(cases);
            var caseMap = Data_StrMap.fromFoldable(Data_Foldable.foldableArray)(cases);
            var extractor = function (dictPartial) {
                return function (v) {
                    var __unused = function (dictPartial1) {
                        return function ($dollar5) {
                            return $dollar5;
                        };
                    };
                    return __unused(dictPartial)((function () {
                        if (v instanceof EnumValue) {
                            return Data_Maybe.fromJust(dictPartial)(Data_StrMap.lookup(Data_Maybe.fromJust(dictPartial)(Data_Array.index(caseNames)(v.value0)))(caseMap));
                        };
                        throw new Error("Failed pattern match at Options line 103, column 9 - line 103, column 55: " + [ v.constructor.name ]);
                    })());
                };
            };
            return {
                specification: {
                    name: name, 
                    description: description, 
                    typeLabel: Data_Foldable.intercalate(Data_Foldable.foldableArray)(Data_Monoid.monoidString)("|")(caseNames), 
                    "default": new EnumValue(0, caseNames)
                }, 
                extractor: function (t) {
                    return extractor()(t);
                }
            };
        };
    };
};
var booleanOption = function (name) {
    return function (description) {
        return function ($$default) {
            var extractor = function (dictPartial) {
                return function (v) {
                    var __unused = function (dictPartial1) {
                        return function ($dollar10) {
                            return $dollar10;
                        };
                    };
                    return __unused(dictPartial)((function () {
                        if (v instanceof BooleanValue) {
                            return v.value0;
                        };
                        throw new Error("Failed pattern match at Options line 86, column 9 - line 86, column 61: " + [ v.constructor.name ]);
                    })());
                };
            };
            return {
                specification: {
                    name: name, 
                    description: description, 
                    typeLabel: "yes|no", 
                    "default": new BooleanValue($$default)
                }, 
                extractor: function (t) {
                    return extractor()(t);
                }
            };
        };
    };
};
module.exports = {
    booleanOption: booleanOption, 
    enumOption: enumOption, 
    lookupOptionValue: lookupOptionValue, 
    makeOptionValues: makeOptionValues
};
//# sourceMappingURL=index.js.map
