// Generated by purs version 0.11.6
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Monad_Except_Trans = require("../Control.Monad.Except.Trans");
var Control_Monad_State_Class = require("../Control.Monad.State.Class");
var Control_Monad_State_Trans = require("../Control.Monad.State.Trans");
var Data_Eq = require("../Data.Eq");
var Data_Filterable = require("../Data.Filterable");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_Identity = require("../Data.Identity");
var Data_List = require("../Data.List");
var Data_List_Types = require("../Data.List.Types");
var Data_Map = require("../Data.Map");
var Data_Maybe = require("../Data.Maybe");
var Data_Ord = require("../Data.Ord");
var Data_Semiring = require("../Data.Semiring");
var Data_Set = require("../Data.Set");
var Data_Tuple = require("../Data.Tuple");
var IR = require("../IR");
var IRGraph = require("../IRGraph");
var Prelude = require("../Prelude");
var similarClasses = function (comparator) {
    return function (graph) {
        var isSimilar = function (cd1) {
            return function (v) {
                return comparator(cd1)(v.value1);
            };
        };
        var accumulate = function (v) {
            if (v instanceof Data_List_Types.Nil) {
                return Data_Set.empty;
            };
            if (v instanceof Data_List_Types.Cons) {
                var v1 = Data_List.partition(isSimilar(v.value0.value1))(v.value1);
                var recursiveResult = accumulate(v1.no);
                if (v1.yes instanceof Data_List_Types.Nil) {
                    return recursiveResult;
                };
                var similarSet = Data_Set.fromFoldable(Data_List_Types.foldableList)(Data_Ord.ordInt)(new Data_List_Types.Cons(v.value0.value0, Data_Functor.map(Data_List_Types.functorList)(Data_Tuple.fst)(v1.yes)));
                return Data_Set.insert(Data_Set.ordSet(Data_Ord.ordInt))(similarSet)(recursiveResult);
            };
            throw new Error("Failed pattern match at Transformations line 42, column 9 - line 42, column 68: " + [ v.constructor.name ]);
        };
        return accumulate(IRGraph.mapClasses(Data_Tuple.Tuple.create)(graph));
    };
};
var replaceClassWithMap = function (i) {
    return Control_Bind.bind(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(IR.getClass(i))(function (v) {
        var types = Data_Map.values(v.properties);
        return Control_Bind.bind(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(IR.unifyMultipleTypes(Data_List_Types.foldableList)(types))(function (v1) {
            return IR.replaceClass(i)(new IRGraph.IRMap(v1));
        });
    });
};
var propertiesSimilar = function (dictEq) {
    return function (pa) {
        return function (pb) {
            var bInA = Data_Map.size(IRGraph.matchingProperties(dictEq)(pb)(pa));
            var aInB = Data_Map.size(IRGraph.matchingProperties(dictEq)(pa)(pb));
            return (aInB * 4 | 0) >= (Data_Map.size(pa) * 3 | 0) && (bInA * 4 | 0) >= (Data_Map.size(pb) * 3 | 0);
        };
    };
};
var makeMaps = (function () {
    var allEqual = function (v) {
        if (v instanceof Data_List_Types.Nil) {
            return true;
        };
        if (v instanceof Data_List_Types.Cons) {
            return Data_Foldable.all(Data_List_Types.foldableList)(Data_HeytingAlgebra.heytingAlgebraBoolean)(Data_Eq.eq(IRGraph.eqIRType)(v.value0))(v.value1);
        };
        throw new Error("Failed pattern match at Transformations line 90, column 9 - line 90, column 30: " + [ v.constructor.name ]);
    };
    var isMapMapper = function (i) {
        return function (v) {
            var types = Data_Map.values(v.properties);
            var isMap = Data_List.length(types) >= 20 && allEqual(types);
            if (isMap) {
                return new Data_Maybe.Just(i);
            };
            return Data_Maybe.Nothing.value;
        };
    };
    return Control_Bind.bind(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.get(Control_Monad_Except_Trans.monadStateExceptT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v) {
        var mapIndexes = Data_Filterable.filtered(Data_Filterable.filterableList)(IRGraph.mapClasses(isMapMapper)(v));
        return Data_Foldable.for_(Control_Monad_Except_Trans.applicativeExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_List_Types.foldableList)(mapIndexes)(function (i) {
            return replaceClassWithMap(i);
        });
    });
})();
var classesSimilar = function (graph) {
    return function (v) {
        return function (v1) {
            return propertiesSimilar(IRGraph.eqIRType)(v.properties)(v1.properties);
        };
    };
};
var classesEqual = function (v) {
    return function (v1) {
        return Data_Eq.eq(Data_Map.eqMap(Data_Eq.eqString)(IRGraph.eqIRType))(v.properties)(v1.properties);
    };
};
var unifyEqualsUntilFixpoint = Control_Bind.bind(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.get(Control_Monad_Except_Trans.monadStateExceptT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v) {
    var equal = similarClasses(classesEqual)(v);
    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Foldable.for_(Control_Monad_Except_Trans.applicativeExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Set.foldableSet)(equal)(IR.unifySetOfClasses))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(IR.followRedirections)(function () {
            return Control_Bind.bind(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.get(Control_Monad_Except_Trans.monadStateExceptT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v1) {
                return Control_Applicative.when(Control_Monad_Except_Trans.applicativeExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Eq.notEq(IRGraph.eqGraph)(v)(v1))(unifyEqualsUntilFixpoint);
            });
        });
    });
});
var replaceSimilarClasses = Control_Bind.bind(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.get(Control_Monad_Except_Trans.monadStateExceptT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v) {
    var similar = similarClasses(classesSimilar(v))(v);
    return Control_Bind.discard(Control_Bind.discardUnit)(Control_Monad_Except_Trans.bindExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Foldable.for_(Control_Monad_Except_Trans.applicativeExceptT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Set.foldableSet)(similar)(IR.unifySetOfClasses))(function () {
        return unifyEqualsUntilFixpoint;
    });
});
module.exports = {
    makeMaps: makeMaps, 
    replaceSimilarClasses: replaceSimilarClasses
};
//# sourceMappingURL=index.js.map
